Index: /trunk/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectPermissionsView.Designer.cs
===================================================================
--- /trunk/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectPermissionsView.Designer.cs	(revision 16426)
+++ /trunk/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectPermissionsView.Designer.cs	(revision 16427)
@@ -112,5 +112,5 @@
       this.permissionsGroupBox.TabIndex = 4;
       this.permissionsGroupBox.TabStop = false;
-      this.permissionsGroupBox.Text = "Permissions (Assigned + Included)";
+      this.permissionsGroupBox.Text = "Compute Permissions (Assigned + Included)";
       // 
       // treeView
Index: /trunk/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectView.Designer.cs
===================================================================
--- /trunk/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectView.Designer.cs	(revision 16426)
+++ /trunk/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectView.Designer.cs	(revision 16427)
@@ -39,6 +39,5 @@
       this.endLabel = new System.Windows.Forms.Label();
       this.indefiniteCheckBox = new System.Windows.Forms.CheckBox();
-      this.createdTextBox = new System.Windows.Forms.TextBox();
-      this.refreshButton = new System.Windows.Forms.Button();
+      this.createdTextBox = new System.Windows.Forms.TextBox();      
       this.toolTip = new System.Windows.Forms.ToolTip(this.components);
       this.SuspendLayout();
@@ -124,15 +123,4 @@
       this.ownerComboBox.SelectedIndexChanged += new System.EventHandler(this.ownerComboBox_SelectedIndexChanged);
       // 
-      // refreshButton
-      // 
-      this.refreshButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Refresh;
-      this.refreshButton.Location = new System.Drawing.Point(278, 162);
-      this.refreshButton.Name = "refreshButton";
-      this.refreshButton.Size = new System.Drawing.Size(24, 24);
-      this.refreshButton.TabIndex = 5;
-      this.toolTip.SetToolTip(this.refreshButton, "Refresh data");
-      this.refreshButton.UseVisualStyleBackColor = true;
-      this.refreshButton.Click += new System.EventHandler(this.refreshButton_Click);
-      // 
       // createdLabel
       // 
@@ -207,5 +195,4 @@
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.Controls.Add(this.refreshButton);
       this.Controls.Add(this.createdTextBox);
       this.Controls.Add(this.indefiniteCheckBox);
@@ -247,6 +234,5 @@
     private System.Windows.Forms.Label endLabel;
     private System.Windows.Forms.CheckBox indefiniteCheckBox;
-    private System.Windows.Forms.TextBox createdTextBox;
-    private System.Windows.Forms.Button refreshButton;
+    private System.Windows.Forms.TextBox createdTextBox;    
     private System.Windows.Forms.ToolTip toolTip;
   }
Index: /trunk/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectView.cs
===================================================================
--- /trunk/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectView.cs	(revision 16426)
+++ /trunk/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectView.cs	(revision 16427)
@@ -126,6 +126,5 @@
       bool enabled = Content != null && !Locked && !ReadOnly;
       nameTextBox.Enabled = enabled;
-      descriptionTextBox.Enabled = enabled;
-      refreshButton.Enabled = enabled;
+      descriptionTextBox.Enabled = enabled;      
       ownerComboBox.Enabled = enabled;
       createdTextBox.Enabled = enabled;
@@ -188,23 +187,4 @@
     }
 
-    private async void refreshButton_Click(object sender, EventArgs e) {
-      lock (locker) {
-        if (!refreshButton.Enabled) return;
-        refreshButton.Enabled = false;
-      }
-
-      await SecurityExceptionUtil.TryAsyncAndReportSecurityExceptions(
-        action: () => UpdateUsers(),
-        finallyCallback: () => {
-          ownerComboBox.SelectedIndexChanged -= ownerComboBox_SelectedIndexChanged;
-          var users = AccessClient.Instance.UsersAndGroups.OfType<LightweightUser>();
-          if (Content != null && !Content.ParentProjectId.HasValue) users = users.Where(x => x.Roles.Select(y => y.Name).Contains(HiveRoles.Administrator));
-          ownerComboBox.DataSource = users.ToList();
-          ownerComboBox.SelectedItem = users.FirstOrDefault(x => x.Id == persistedOwnerUserId);
-          ownerComboBox.SelectedIndexChanged += ownerComboBox_SelectedIndexChanged;
-          refreshButton.Enabled = true;
-        });
-    }
-
     private void nameTextBox_Validating(object sender, CancelEventArgs e) {
       if (string.IsNullOrEmpty(nameTextBox.Text)) {
Index: /trunk/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectsView.Designer.cs
===================================================================
--- /trunk/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectsView.Designer.cs	(revision 16426)
+++ /trunk/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectsView.Designer.cs	(revision 16427)
@@ -194,5 +194,5 @@
       this.permissionsTabPage.Size = new System.Drawing.Size(577, 515);
       this.permissionsTabPage.TabIndex = 1;
-      this.permissionsTabPage.Text = "Permissions";
+      this.permissionsTabPage.Text = "Compute Permissions";
       this.permissionsTabPage.UseVisualStyleBackColor = true;
       // 
Index: /trunk/HeuristicLab.Clients.Hive.JobManager/3.3/Views/HiveResourceSelector.Designer.cs
===================================================================
--- /trunk/HeuristicLab.Clients.Hive.JobManager/3.3/Views/HiveResourceSelector.Designer.cs	(revision 16426)
+++ /trunk/HeuristicLab.Clients.Hive.JobManager/3.3/Views/HiveResourceSelector.Designer.cs	(revision 16427)
@@ -19,4 +19,6 @@
  */
 #endregion
+
+using System.Windows.Forms;
 
 namespace HeuristicLab.Clients.Hive.JobManager.Views {
@@ -114,4 +116,5 @@
       this.toolTip.SetToolTip(this.searchTextBox, "Enter string to search for resources");
       this.searchTextBox.TextChanged += new System.EventHandler(this.searchTextBox_TextChanged);
+      this.searchTextBox.MouseDown += new MouseEventHandler(this.searchTextBox_MouseDown);
       // 
       // splitContainer2
@@ -146,4 +149,5 @@
       this.projectsTreeView.Size = new System.Drawing.Size(204, 410);
       this.projectsTreeView.TabIndex = 3;
+      this.projectsTreeView.MouseDown += new System.Windows.Forms.MouseEventHandler(this.projectsTreeView_MouseDown);
       this.projectsTreeView.MouseDoubleClick += new System.Windows.Forms.MouseEventHandler(this.projectsTreeView_MouseDoubleClick);
       this.projectsTreeView.BeforeSelect += new System.Windows.Forms.TreeViewCancelEventHandler(this.projectsTreeView_BeforeSelect);
Index: /trunk/HeuristicLab.Clients.Hive.JobManager/3.3/Views/HiveResourceSelector.cs
===================================================================
--- /trunk/HeuristicLab.Clients.Hive.JobManager/3.3/Views/HiveResourceSelector.cs	(revision 16426)
+++ /trunk/HeuristicLab.Clients.Hive.JobManager/3.3/Views/HiveResourceSelector.cs	(revision 16427)
@@ -145,5 +145,5 @@
         selectedProject = value;
 
-        UpdateResourceTree();
+        UpdateResourceTree();                
         ExtractStatistics();
         OnSelectedProjectChanged();
@@ -223,4 +223,14 @@
       //UpdateFilteredTree();
       UpdateProjectTree();
+    }
+
+    private void searchTextBox_MouseDown(object sender, MouseEventArgs e) {
+      resourcesTreeView.SelectedNode = null;
+      ExtractStatistics();
+    }
+
+    private void projectsTreeView_MouseDown(object sender, MouseEventArgs e) {
+      resourcesTreeView.SelectedNode = null;
+      ExtractStatistics();
     }
 