Index: trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Physics/AircraftLift.cs
===================================================================
--- trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Physics/AircraftLift.cs	(revision 16394)
+++ trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Physics/AircraftLift.cs	(revision 16431)
@@ -26,5 +26,5 @@
 
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
-  class AircraftLift : ArtificialRegressionDataDescriptor {
+  public class AircraftLift : ArtificialRegressionDataDescriptor {
     public override string Name { get { return "Aircraft Lift Coefficient C_L = C_La (a - a0) + C_Ld_e d_e S_HT / S_ref"; } }
 
Index: trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Physics/AircraftMaximumLift.cs
===================================================================
--- trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Physics/AircraftMaximumLift.cs	(revision 16394)
+++ trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Physics/AircraftMaximumLift.cs	(revision 16431)
@@ -26,5 +26,5 @@
 
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
-  class AircraftMaximumLift : ArtificialRegressionDataDescriptor {
+  public class AircraftMaximumLift : ArtificialRegressionDataDescriptor {
     public override string Name { get { return "Aircraft Maximum Lift Coefficient f(X) = x1 - 1/4 x4 x5 x6 (4 + 0.1 x2/x3 - x2²/x3²) + x13 x14/x15 x18 x7 - x13 x14/x15 x8 + x13 x14/x15 x9 + x16 x17/x15 x18 x10 - x16 x17/x15 x11 + x16 x17/x15 x12"; } }
 
Index: trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Physics/FluidDynamics.cs
===================================================================
--- trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Physics/FluidDynamics.cs	(revision 16394)
+++ trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Physics/FluidDynamics.cs	(revision 16431)
@@ -26,5 +26,5 @@
 
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
-  class FluidDynamics : ArtificialRegressionDataDescriptor {
+  public class FluidDynamics : ArtificialRegressionDataDescriptor {
     public override string Name { get { return "Flow Psi = V_inf r sin(th) (1 - R²/r²) + G/(2 π) ln(r/R)"; } }
 
Index: trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Physics/PhysicsInstanceProvider.cs
===================================================================
--- trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Physics/PhysicsInstanceProvider.cs	(revision 16394)
+++ trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Physics/PhysicsInstanceProvider.cs	(revision 16431)
@@ -22,17 +22,8 @@
 using System;
 using System.Collections.Generic;
+using HeuristicLab.Random;
 
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
-  class PhysicsInstanceProvider : ArtificialRegressionInstanceProvider {
-    public override IEnumerable<IDataDescriptor> GetDataDescriptors() {
-      return new List<IDataDescriptor>()
-      {
-         new RocketFuelFlow(123),
-         new AircraftLift(456),
-         new FluidDynamics(789),
-         new AircraftMaximumLift(321)
-      };
-    }
-
+  public class PhysicsInstanceProvider : ArtificialRegressionInstanceProvider {
     public override string Name { get { return "Physics Benchmark Problems"; } }
     public override string Description { get { return ""; } }
@@ -43,4 +34,24 @@
       }
     }
+
+    public int Seed { get; private set; }
+
+    public PhysicsInstanceProvider() : this((int)DateTime.Now.Ticks) { }
+
+    public PhysicsInstanceProvider(int seed) : base() {
+      Seed = seed;
+    }
+
+    public override IEnumerable<IDataDescriptor> GetDataDescriptors() {
+      var rand = new FastRandom(Seed);
+
+      return new List<IDataDescriptor>()
+      {
+         new RocketFuelFlow(rand.Next()),
+         new AircraftLift(rand.Next()),
+         new FluidDynamics(rand.Next()),
+         new AircraftMaximumLift(rand.Next())
+      };
+    }
   }
 }
Index: trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Physics/RocketFuelFlow.cs
===================================================================
--- trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Physics/RocketFuelFlow.cs	(revision 16394)
+++ trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Physics/RocketFuelFlow.cs	(revision 16431)
@@ -26,5 +26,5 @@
 
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
-  class RocketFuelFlow : ArtificialRegressionDataDescriptor {
+  public class RocketFuelFlow : ArtificialRegressionDataDescriptor {
     public override string Name { get { return "Rocket Fuel Flow m_dot = p0 A / sqrt(T0) * sqrt(γ/R (2/(γ+1))^((γ+1) / (γ-1)))"; } }
 