Index: branches/2965_CancelablePersistence/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectJobsView.cs
===================================================================
--- branches/2965_CancelablePersistence/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectJobsView.cs	(revision 16321)
+++ branches/2965_CancelablePersistence/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectJobsView.cs	(revision 16433)
@@ -75,5 +75,5 @@
       progress = new Progress();
 
-      removeButton.Enabled = false;      
+      removeButton.Enabled = false;
     }
 
@@ -81,10 +81,10 @@
       base.RegisterContentEvents();
       matrixView.DataGridView.SelectionChanged += DataGridView_SelectionChanged;
-      MainFormManager.GetMainForm<HeuristicLab.MainForm.WindowsForms.MainForm>().AddOperationProgressToView(this, progress);
+      MainForm.Progress.Show(this, progress);
     }
 
     protected override void DeregisterContentEvents() {
       matrixView.DataGridView.SelectionChanged -= DataGridView_SelectionChanged;
-      MainFormManager.GetMainForm<HeuristicLab.MainForm.WindowsForms.MainForm>().RemoveOperationProgressFromView(this, false);
+      MainForm.Progress.Hide(this, false);
       base.DeregisterContentEvents();
     }
@@ -114,5 +114,5 @@
         var jobs = GetSelectedJobs().ToList();
         if (jobs.Any()) {
-                    
+
           startButton.Enabled = jobs.All(x =>
             !x.IsProgressing && HiveAdminClient.Instance.Tasks.ContainsKey(x.Id) && HiveAdminClient.Instance.Tasks[x.Id].Count > 0
@@ -135,14 +135,14 @@
     #region Event Handlers
     private void ProjectJobsView_Load(object sender, EventArgs e) {
-      
+
     }
 
     private void refreshButton_Click(object sender, EventArgs e) {
-      progress.Start("Refreshing jobs...");
+      progress.Start("Refreshing jobs...", ProgressMode.Indeterminate);
       SetEnabledStateOfControls();
       var task = System.Threading.Tasks.Task.Factory.StartNew(RefreshJobsAsync);
 
       task.ContinueWith((t) => {
-        progress.Finish();        
+        progress.Finish();
         SetEnabledStateOfControls();
       });
@@ -160,5 +160,5 @@
 
         if (result == DialogResult.Yes) {
-          progress.Start("Removing job(s)...");
+          progress.Start("Removing job(s)...", ProgressMode.Indeterminate);
           SetEnabledStateOfControls();
           var task = System.Threading.Tasks.Task.Factory.StartNew(RemoveJobsAsync, jobs);
@@ -191,10 +191,10 @@
 
         if (result == DialogResult.Yes) {
-          progress.Start("Resuming job(s)...");
+          progress.Start("Resuming job(s)...", ProgressMode.Indeterminate);
           SetEnabledStateOfControls();
           var task = System.Threading.Tasks.Task.Factory.StartNew(ResumeJobsAsync, jobs);
 
           task.ContinueWith((t) => {
-            RefreshJobs();            
+            RefreshJobs();
             progress.Finish();
             SetEnabledStateOfControls();
@@ -227,5 +227,5 @@
 
           task.ContinueWith((t) => {
-            RefreshJobs();            
+            RefreshJobs();
             progress.Finish();
             SetEnabledStateOfControls();
@@ -253,5 +253,5 @@
 
         if (result == DialogResult.Yes) {
-          progress.Start("Stopping job(s)...");
+          progress.Start("Stopping job(s)...", ProgressMode.Indeterminate);
           SetEnabledStateOfControls();
           var task = System.Threading.Tasks.Task.Factory.StartNew(StopJobsAsync, jobs);
@@ -267,5 +267,5 @@
             progress.Finish();
             SetEnabledStateOfControls();
-            MessageBox.Show("An error occured stopping the job(s).", "HeuristicLab Hive Administrator", MessageBoxButtons.OK, MessageBoxIcon.Error);            
+            MessageBox.Show("An error occured stopping the job(s).", "HeuristicLab Hive Administrator", MessageBoxButtons.OK, MessageBoxIcon.Error);
           }, TaskContinuationOptions.OnlyOnFaulted);
         }
@@ -284,10 +284,10 @@
     private IEnumerable<RefreshableJob> GetSelectedJobs() {
       if (Content == null || matrixView.DataGridView.SelectedRows == null || matrixView.DataGridView.SelectedRows.Count == 0)
-        return Enumerable.Empty<RefreshableJob>() ;
+        return Enumerable.Empty<RefreshableJob>();
 
       var jobs = new List<RefreshableJob>();
       foreach (DataGridViewRow r in matrixView.DataGridView.SelectedRows) {
         if (((string)r.Cells[0].Value) == JobState.Online.ToString()) {
-          jobs.Add(HiveAdminClient.Instance.Jobs[Content.Id].FirstOrDefault(x => x.Id == Guid.Parse((string) r.Cells[11].Value)));
+          jobs.Add(HiveAdminClient.Instance.Jobs[Content.Id].FirstOrDefault(x => x.Id == Guid.Parse((string)r.Cells[11].Value)));
         }
       }
@@ -310,6 +310,6 @@
       string[,] values = new string[jobs.Count, 13];
 
-      for(int i = 0; i < jobs.Count; i++) {
-        var job = jobs.ElementAt(i);        
+      for (int i = 0; i < jobs.Count; i++) {
+        var job = jobs.ElementAt(i);
         values[i, 0] = job.Job.State.ToString();
         values[i, 1] = job.ExecutionState.ToString();
@@ -322,9 +322,9 @@
         values[i, 8] = job.Job.CalculatingCount.ToString();
         values[i, 9] = job.Job.FinishedCount.ToString();
-        values[i, 10] = job.Job.Description;        
+        values[i, 10] = job.Job.Description;
         values[i, 11] = job.Job.Id.ToString();
         values[i, 12] = job.Job.OwnerUserId.ToString();
       }
-      
+
       var matrix = new StringMatrix(values);
       matrix.ColumnNames = new string[] { JOB_STATE, JOB_EXECUTIONSTATE, JOB_EXECUTIONTIME, JOB_DATECREATED, JOB_OWNER, JOB_NAME, JOB_TASKCOUNT, JOB_WAITINGTASKCOUNT, JOB_CALCULATINGTASKCOUNT, JOB_FINISHEDTASKCOUNT, JOB_DESCRIPTION, JOB_ID, JOB_OWNERID };
@@ -332,12 +332,12 @@
       return matrix;
     }
-    
+
     private void UpdateJobs() {
       if (InvokeRequired) Invoke((Action)UpdateJobs);
       else {
-        if(Content != null && Content.Id != null && Content.Id != Guid.Empty) {
+        if (Content != null && Content.Id != null && Content.Id != Guid.Empty) {
           var matrix = CreateValueMatrix();
           matrixView.Content = matrix;
-          if(matrix != null) {
+          if (matrix != null) {
             foreach (DataGridViewRow row in matrixView.DataGridView.Rows) {
               string val = ((string)row.Cells[0].Value);
@@ -355,5 +355,5 @@
             matrixView.DataGridView.Columns[1].MinimumWidth = 108;
           }
-        } 
+        }
       }
     }
@@ -367,5 +367,5 @@
       var jobList = (IEnumerable<RefreshableJob>)jobs;
       foreach (var job in jobList) {
-        progress.Status = "Resuming job \"" + job.Job.Name + "\"...";
+        progress.Message = "Resuming job \"" + job.Job.Name + "\"...";
         HiveAdminClient.ResumeJob(job);
       }
@@ -375,5 +375,5 @@
       var jobList = (IEnumerable<RefreshableJob>)jobs;
       foreach (var job in jobList) {
-        progress.Status = "Pausing job \"" + job.Job.Name + "\"...";
+        progress.Message = "Pausing job \"" + job.Job.Name + "\"...";
         HiveAdminClient.PauseJob(job);
       }
@@ -381,7 +381,7 @@
 
     private void StopJobsAsync(object jobs) {
-      var jobList = (IEnumerable<RefreshableJob>) jobs;
-      foreach (var job in jobList) {        
-        progress.Status = "Stopping job \"" + job.Job.Name + "\"...";
+      var jobList = (IEnumerable<RefreshableJob>)jobs;
+      foreach (var job in jobList) {
+        progress.Message = "Stopping job \"" + job.Job.Name + "\"...";
         HiveAdminClient.StopJob(job);
       }
@@ -390,7 +390,7 @@
     private void RemoveJobsAsync(object jobs) {
       var jobList = (IEnumerable<RefreshableJob>)jobs;
-      progress.Start();
+      progress.Start("", ProgressMode.Indeterminate);
       foreach (var job in jobList) {
-        progress.Status = "Removing job \"" + job.Job.Name + "\"...";
+        progress.Message = "Removing job \"" + job.Job.Name + "\"...";
         HiveAdminClient.RemoveJob(job);
       }
Index: branches/2965_CancelablePersistence/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectPermissionsView.Designer.cs
===================================================================
--- branches/2965_CancelablePersistence/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectPermissionsView.Designer.cs	(revision 16321)
+++ branches/2965_CancelablePersistence/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectPermissionsView.Designer.cs	(revision 16433)
@@ -112,5 +112,5 @@
       this.permissionsGroupBox.TabIndex = 4;
       this.permissionsGroupBox.TabStop = false;
-      this.permissionsGroupBox.Text = "Permissions (Assigned + Included)";
+      this.permissionsGroupBox.Text = "Compute Permissions (Assigned + Included)";
       // 
       // treeView
Index: branches/2965_CancelablePersistence/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectView.Designer.cs
===================================================================
--- branches/2965_CancelablePersistence/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectView.Designer.cs	(revision 16321)
+++ branches/2965_CancelablePersistence/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectView.Designer.cs	(revision 16433)
@@ -39,6 +39,5 @@
       this.endLabel = new System.Windows.Forms.Label();
       this.indefiniteCheckBox = new System.Windows.Forms.CheckBox();
-      this.createdTextBox = new System.Windows.Forms.TextBox();
-      this.refreshButton = new System.Windows.Forms.Button();
+      this.createdTextBox = new System.Windows.Forms.TextBox();      
       this.toolTip = new System.Windows.Forms.ToolTip(this.components);
       this.SuspendLayout();
@@ -124,15 +123,4 @@
       this.ownerComboBox.SelectedIndexChanged += new System.EventHandler(this.ownerComboBox_SelectedIndexChanged);
       // 
-      // refreshButton
-      // 
-      this.refreshButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Refresh;
-      this.refreshButton.Location = new System.Drawing.Point(278, 162);
-      this.refreshButton.Name = "refreshButton";
-      this.refreshButton.Size = new System.Drawing.Size(24, 24);
-      this.refreshButton.TabIndex = 5;
-      this.toolTip.SetToolTip(this.refreshButton, "Refresh data");
-      this.refreshButton.UseVisualStyleBackColor = true;
-      this.refreshButton.Click += new System.EventHandler(this.refreshButton_Click);
-      // 
       // createdLabel
       // 
@@ -207,5 +195,4 @@
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.Controls.Add(this.refreshButton);
       this.Controls.Add(this.createdTextBox);
       this.Controls.Add(this.indefiniteCheckBox);
@@ -247,6 +234,5 @@
     private System.Windows.Forms.Label endLabel;
     private System.Windows.Forms.CheckBox indefiniteCheckBox;
-    private System.Windows.Forms.TextBox createdTextBox;
-    private System.Windows.Forms.Button refreshButton;
+    private System.Windows.Forms.TextBox createdTextBox;    
     private System.Windows.Forms.ToolTip toolTip;
   }
Index: branches/2965_CancelablePersistence/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectView.cs
===================================================================
--- branches/2965_CancelablePersistence/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectView.cs	(revision 16321)
+++ branches/2965_CancelablePersistence/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectView.cs	(revision 16433)
@@ -127,5 +127,4 @@
       nameTextBox.Enabled = enabled;
       descriptionTextBox.Enabled = enabled;
-      refreshButton.Enabled = enabled;
       ownerComboBox.Enabled = enabled;
       createdTextBox.Enabled = enabled;
@@ -161,6 +160,5 @@
       if (InvokeRequired) Invoke((Action<object, EventArgs>)AccessClient_Instance_Refreshing, sender, e);
       else {
-        var mainForm = MainFormManager.GetMainForm<MainForm.WindowsForms.MainForm>();
-        mainForm.AddOperationProgressToView(this, "Refreshing ...");
+        Progress.Show(this, "Refreshing ...", ProgressMode.Indeterminate);
         SetEnabledStateOfControls();
       }
@@ -170,6 +168,5 @@
       if (InvokeRequired) Invoke((Action<object, EventArgs>)AccessClient_Instance_Refreshed, sender, e);
       else {
-        var mainForm = MainFormManager.GetMainForm<MainForm.WindowsForms.MainForm>();
-        mainForm.RemoveOperationProgressFromView(this);
+        Progress.Hide(this);
         SetEnabledStateOfControls();
       }
@@ -188,23 +185,4 @@
     }
 
-    private async void refreshButton_Click(object sender, EventArgs e) {
-      lock (locker) {
-        if (!refreshButton.Enabled) return;
-        refreshButton.Enabled = false;
-      }
-
-      await SecurityExceptionUtil.TryAsyncAndReportSecurityExceptions(
-        action: () => UpdateUsers(),
-        finallyCallback: () => {
-          ownerComboBox.SelectedIndexChanged -= ownerComboBox_SelectedIndexChanged;
-          var users = AccessClient.Instance.UsersAndGroups.OfType<LightweightUser>();
-          if (Content != null && !Content.ParentProjectId.HasValue) users = users.Where(x => x.Roles.Select(y => y.Name).Contains(HiveRoles.Administrator));
-          ownerComboBox.DataSource = users.ToList();
-          ownerComboBox.SelectedItem = users.FirstOrDefault(x => x.Id == persistedOwnerUserId);
-          ownerComboBox.SelectedIndexChanged += ownerComboBox_SelectedIndexChanged;
-          refreshButton.Enabled = true;
-        });
-    }
-
     private void nameTextBox_Validating(object sender, CancelEventArgs e) {
       if (string.IsNullOrEmpty(nameTextBox.Text)) {
Index: branches/2965_CancelablePersistence/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectsView.Designer.cs
===================================================================
--- branches/2965_CancelablePersistence/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectsView.Designer.cs	(revision 16321)
+++ branches/2965_CancelablePersistence/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectsView.Designer.cs	(revision 16433)
@@ -194,5 +194,5 @@
       this.permissionsTabPage.Size = new System.Drawing.Size(577, 515);
       this.permissionsTabPage.TabIndex = 1;
-      this.permissionsTabPage.Text = "Permissions";
+      this.permissionsTabPage.Text = "Compute Permissions";
       this.permissionsTabPage.UseVisualStyleBackColor = true;
       // 
Index: branches/2965_CancelablePersistence/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectsView.cs
===================================================================
--- branches/2965_CancelablePersistence/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectsView.cs	(revision 16321)
+++ branches/2965_CancelablePersistence/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectsView.cs	(revision 16433)
@@ -43,5 +43,5 @@
     private const string NOT_STORED_TAG = "*"; // " [not stored]";
     private const string CHANGES_NOT_STORED_TAG = "*"; // " [changes not stored]";
-    private const string INACTIVE_TAG = " [inactive]"; 
+    private const string INACTIVE_TAG = " [inactive]";
 
     private readonly Color selectedBackColor = Color.DodgerBlue;
@@ -111,9 +111,9 @@
 
     protected override void SetEnabledStateOfControls() {
-      base.SetEnabledStateOfControls();      
-
-      bool locked = Content == null || Locked || ReadOnly;      
+      base.SetEnabledStateOfControls();
+
+      bool locked = Content == null || Locked || ReadOnly;
       bool parentOwner = selectedProject != null && HiveAdminClient.Instance.CheckOwnershipOfParentProject(selectedProject, UserInformation.Instance.User.Id);
-      bool selectedProjectDisabled = selectedProject == null 
+      bool selectedProjectDisabled = selectedProject == null
                                      || selectedProject != null && selectedProject.Id == Guid.Empty;
 
@@ -183,6 +183,5 @@
       if (InvokeRequired) Invoke((Action<object, EventArgs>)HiveAdminClient_Instance_Refreshing, sender, e);
       else {
-        var mainForm = MainFormManager.GetMainForm<MainForm.WindowsForms.MainForm>();
-        mainForm.AddOperationProgressToView(this, "Refreshing ...");
+        Progress.Show(this, "Refreshing ...", ProgressMode.Indeterminate);
         SetEnabledStateOfControls();
       }
@@ -192,6 +191,5 @@
       if (InvokeRequired) Invoke((Action<object, EventArgs>)HiveAdminClient_Instance_Refreshed, sender, e);
       else {
-        var mainForm = MainFormManager.GetMainForm<MainForm.WindowsForms.MainForm>();
-        mainForm.RemoveOperationProgressFromView(this);
+        Progress.Hide(this);
         SetEnabledStateOfControls();
       }
@@ -201,6 +199,5 @@
       if (InvokeRequired) Invoke((Action<object, EventArgs>)AccessClient_Instance_Refreshing, sender, e);
       else {
-        var mainForm = MainFormManager.GetMainForm<MainForm.WindowsForms.MainForm>();
-        mainForm.AddOperationProgressToView(this, "Refreshing ...");
+        Progress.Show(this, "Refreshing ...", ProgressMode.Indeterminate);
         SetEnabledStateOfControls();
       }
@@ -210,6 +207,5 @@
       if (InvokeRequired) Invoke((Action<object, EventArgs>)AccessClient_Instance_Refreshed, sender, e);
       else {
-        var mainForm = MainFormManager.GetMainForm<MainForm.WindowsForms.MainForm>();
-        mainForm.RemoveOperationProgressFromView(this);
+        Progress.Hide(this);
         SetEnabledStateOfControls();
       }
@@ -234,5 +230,5 @@
     }
 
-    private void addButton_Click(object sender, EventArgs e) {      
+    private void addButton_Click(object sender, EventArgs e) {
 
       if (selectedProject == null && !IsAdmin()) {
@@ -244,5 +240,5 @@
         return;
       }
-      
+
       if (selectedProject != null && selectedProject.Id == Guid.Empty) {
         MessageBox.Show(
@@ -256,7 +252,7 @@
       var project = new Project {
         Name = "New Project",
-        OwnerUserId = UserInformation.Instance.User.Id,        
+        OwnerUserId = UserInformation.Instance.User.Id,
       };
-      if(selectedProject != null) {
+      if (selectedProject != null) {
         project.ParentProjectId = selectedProject.Id;
         project.EndDate = selectedProject.EndDate;
@@ -285,5 +281,5 @@
         await SecurityExceptionUtil.TryAsyncAndReportSecurityExceptions(
           action: () => {
-            RemoveProject(selectedProject);  
+            RemoveProject(selectedProject);
           });
       }
@@ -304,5 +300,5 @@
           foreach (var project in projectsToSave)
             project.Store();
-          
+
           UpdateProjects();
         },
@@ -316,5 +312,5 @@
       if (node == null) return;
       var p = (Project)node.Tag;
-      if(!HiveAdminClient.Instance.DisabledParentProjects.Contains(p)) ChangeSelectedProjectNode(node);
+      if (!HiveAdminClient.Instance.DisabledParentProjects.Contains(p)) ChangeSelectedProjectNode(node);
     }
 
@@ -357,5 +353,5 @@
       if (targetNode == null) {
         treeView.Nodes.Add(sourceNode);
-      } else if(targetProject.Id != Guid.Empty) {
+      } else if (targetProject.Id != Guid.Empty) {
         targetNode.Nodes.Add(sourceNode);
         sourceProject.ParentProjectId = targetProject.Id;
@@ -422,5 +418,5 @@
         var newNode = new TreeNode(newProject.Name) { Tag = newProject };
         StyleTreeNode(newNode, newProject);
-      
+
         if (selectedProject == null && !disabledParentProjects.Contains(newProject)) {
           SelectedProject = newProject;
@@ -533,7 +529,7 @@
         if (project.Id != Guid.Empty) {
           SelectedProject = HiveAdminClient.Instance.GetAvailableProjectAncestors(project.Id).LastOrDefault();
-          HiveAdminClient.Delete(project);          
+          HiveAdminClient.Delete(project);
           UpdateProjects();
-        } else {          
+        } else {
           SelectedProject = Content.FirstOrDefault(x => x.Id == project.ParentProjectId);
           Content.Remove(project);
Index: branches/2965_CancelablePersistence/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ResourcesView.cs
===================================================================
--- branches/2965_CancelablePersistence/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ResourcesView.cs	(revision 16321)
+++ branches/2965_CancelablePersistence/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ResourcesView.cs	(revision 16433)
@@ -185,6 +185,5 @@
       if (InvokeRequired) Invoke((Action<object, EventArgs>)HiveAdminClient_Instance_Refreshing, sender, e);
       else {
-        var mainForm = MainFormManager.GetMainForm<MainForm.WindowsForms.MainForm>();
-        mainForm.AddOperationProgressToView(this, "Refreshing ...");
+        Progress.Show(this, "Refreshing ...", ProgressMode.Indeterminate);
         SetEnabledStateOfControls();
       }
@@ -194,6 +193,5 @@
       if (InvokeRequired) Invoke((Action<object, EventArgs>)HiveAdminClient_Instance_Refreshed, sender, e);
       else {
-        var mainForm = MainFormManager.GetMainForm<MainForm.WindowsForms.MainForm>();
-        mainForm.RemoveOperationProgressFromView(this);
+        Progress.Hide(this);
         SetEnabledStateOfControls();
       }
@@ -203,6 +201,5 @@
       if (InvokeRequired) Invoke((Action<object, EventArgs>)AccessClient_Instance_Refreshing, sender, e);
       else {
-        var mainForm = MainFormManager.GetMainForm<MainForm.WindowsForms.MainForm>();
-        mainForm.AddOperationProgressToView(this, "Refreshing ...");
+        Progress.Show(this, "Refreshing ...", ProgressMode.Indeterminate);
         SetEnabledStateOfControls();
       }
@@ -212,6 +209,5 @@
       if (InvokeRequired) Invoke((Action<object, EventArgs>)AccessClient_Instance_Refreshed, sender, e);
       else {
-        var mainForm = MainFormManager.GetMainForm<MainForm.WindowsForms.MainForm>();
-        mainForm.RemoveOperationProgressFromView(this);
+        Progress.Hide(this);
         SetEnabledStateOfControls();
       }
@@ -247,5 +243,5 @@
     }
 
-    private async void btnRemoveGroup_Click(object sender, EventArgs e) {      
+    private async void btnRemoveGroup_Click(object sender, EventArgs e) {
       var nodes = GetCheckedNodes(treeView.Nodes).ToList();
       var checkedResources = nodes.Select(x => x.Tag).OfType<Resource>().ToList();
@@ -574,5 +570,5 @@
           foreach (var nr in newResources) Content.Remove(nr);
 
-          HiveAdminClient.Delete(resource);          
+          HiveAdminClient.Delete(resource);
           UpdateResources();
         } else {
@@ -588,10 +584,10 @@
       if (resources == null || !resources.Any()) return;
 
-      var ids = resources.Select(x => x.Id).ToList();      
+      var ids = resources.Select(x => x.Id).ToList();
       try {
         bool update = false;
-        foreach (var r in resources) {          
-          if (r.Id != Guid.Empty)  {
-            if(r.Id == SelectedResource.Id)
+        foreach (var r in resources) {
+          if (r.Id != Guid.Empty) {
+            if (r.Id == SelectedResource.Id)
               SelectedResource = HiveAdminClient.Instance.GetAvailableResourceAncestors(r.Id).LastOrDefault();
 
@@ -751,5 +747,5 @@
 
       foreach (var r in resources) {
-        if(!resourceDescendants.ContainsKey(r.Id))
+        if (!resourceDescendants.ContainsKey(r.Id))
           resourceDescendants.Add(r.Id, new HashSet<Resource>());
       }