Index: addons/HeuristicLab.Problems.BioBoost/HeuristicLab.Problems.BioBoost.Views/3.3/BioBoostCompoundSolutionEditor.cs
===================================================================
--- addons/HeuristicLab.Problems.BioBoost/HeuristicLab.Problems.BioBoost.Views/3.3/BioBoostCompoundSolutionEditor.cs	(revision 15711)
+++ addons/HeuristicLab.Problems.BioBoost/HeuristicLab.Problems.BioBoost.Views/3.3/BioBoostCompoundSolutionEditor.cs	(revision 16447)
@@ -583,7 +583,7 @@
     private void optimizeTransportsButton_Click(object sender, EventArgs e) {
       using (BackgroundWorker bg = new BackgroundWorker()) {
-        MainFormManager.GetMainForm<MainForm.WindowsForms.MainForm>().AddOperationProgressToView(this, "Optimizing Transports...");
+        Progress.Show(this, "Optimizing Transports...", ProgressMode.Indeterminate);
         bg.DoWork += (o, a) => OptimizeTransports();
-        bg.RunWorkerCompleted += (o, a) => MainFormManager.GetMainForm<MainForm.WindowsForms.MainForm>().RemoveOperationProgressFromView(this);
+        bg.RunWorkerCompleted += (o, a) => Progress.Hide(this);
         bg.RunWorkerAsync();
       }
@@ -592,7 +592,7 @@
     private void optimizeUtilizationsButton_Click(object sender, EventArgs e) {
       using (BackgroundWorker bg = new BackgroundWorker()) {
-        MainFormManager.GetMainForm<MainForm.WindowsForms.MainForm>().AddOperationProgressToView(this, "Optimizing Utilizations...");
+        Progress.Show(this, "Optimizing Utilizations...", ProgressMode.Indeterminate);
         bg.DoWork += (o, a) => OptimizeUtilizations();
-        bg.RunWorkerCompleted += (o, a) => MainFormManager.GetMainForm<MainForm.WindowsForms.MainForm>().RemoveOperationProgressFromView(this);
+        bg.RunWorkerCompleted += (o, a) => Progress.Hide(this);
         bg.RunWorkerAsync();
       }
Index: addons/HeuristicLab.Problems.BioBoost/HeuristicLab.Problems.BioBoost.Views/3.3/MenuItems/CreateBioBoostExperimentMenuItem.cs
===================================================================
--- addons/HeuristicLab.Problems.BioBoost/HeuristicLab.Problems.BioBoost.Views/3.3/MenuItems/CreateBioBoostExperimentMenuItem.cs	(revision 15711)
+++ addons/HeuristicLab.Problems.BioBoost/HeuristicLab.Problems.BioBoost.Views/3.3/MenuItems/CreateBioBoostExperimentMenuItem.cs	(revision 16447)
@@ -79,9 +79,7 @@
     public override void Execute() {
       IContentView activeView = (IContentView)MainFormManager.MainForm.ActiveView;
-      var mainForm = ((MainForm.WindowsForms.MainForm) MainFormManager.MainForm);
-      var progress = mainForm.AddOperationProgressToContent(activeView.Content, "Generating Algorithm Configurations");
+      var progress = Progress.Show(activeView.Content, "Generating Algorithm Configurations");
       int n = nValues(typeof (Pathway))*nValues(typeof (Region))*nValues(typeof (Price))* nValues(typeof (Implementation));
       int count = 0;
-      progress.Start();
       progress.ProgressValue = 1.0*count/n;
       var alg = activeView.Content as IAlgorithm;
@@ -119,5 +117,5 @@
           dialog.ShowDialog();
         }
-        mainForm.RemoveOperationProgressFromContent(activeView.Content);
+        Progress.Hide(activeView.Content);
       }, null);
 
Index: addons/HeuristicLab.Problems.BioBoost/HeuristicLab.Problems.BioBoost.Views/3.3/MenuItems/ExportSolutionMenuItem.cs
===================================================================
--- addons/HeuristicLab.Problems.BioBoost/HeuristicLab.Problems.BioBoost.Views/3.3/MenuItems/ExportSolutionMenuItem.cs	(revision 15711)
+++ addons/HeuristicLab.Problems.BioBoost/HeuristicLab.Problems.BioBoost.Views/3.3/MenuItems/ExportSolutionMenuItem.cs	(revision 16447)
@@ -86,6 +86,5 @@
         var folderName = folderBrowserDialog.SelectedPath;
         IContentView activeView = (IContentView)MainFormManager.MainForm.ActiveView;
-        var mainForm = (MainForm.WindowsForms.MainForm)MainFormManager.MainForm;
-        mainForm.AddOperationProgressToContent(activeView.Content, "Export solutions.");
+        Progress.Show(activeView.Content, "Export solutions.", ProgressMode.Indeterminate);
 
         Action<IContentView> action = (view) => {
@@ -119,5 +118,5 @@
             dialog.ShowDialog();
           }
-          mainForm.RemoveOperationProgressFromContent(activeView.Content);
+          Progress.Hide(activeView.Content);
         }, null);
       }